#%RAML 1.0 Library
type: object
displayName: Amostra
description: Dados da amostra em qualquer momento do processo.
properties: 
    numero: 
        type: string 
        required: true
        description: Número da amostra. Identifica de forma única a amostra no sistema.
    codigoExterno:
        required: false
        type: string
        description: Identificador da amostra para o cliente. Campo de uso exclusivo do cliente.
    idioma:
        required: true
        type: string
    situacao:
        type: string
        enum: [AGUARDANDO, COLETADA, EM_PROCESSAMENTO, SEGREGADA, FINALIZADA, CANCELADA]
        description: Situação da amostra.
    cliente:
        type: object
        required: false
        properties:
            id:
                type: integer
                description: Identificador único do cliente no sistema.
            nome:
                type: string
                description: Nome do cliente no sistema.
    obra:
        type: object
        required: false
        properties:
            id:
                type: integer
                description: Identificador único da obra/unidade no sistema.
            nome:
                type: string
                description: Nome da obra e/ou unidade no sistema.
    programa:
        type: object
        required: false
        properties:
            id:
                type: integer
                description: Identificador único do programa.
            nome:
                type: string
                description: Nome do programa.
    validoNoPrograma:
        type: boolean
        description: Informa se a amostra está ou não válida no programa, caso esteja no programa.
    houvePreRegistro:
        type: boolean
        description: Informa se a amostra teve o registro de coleta feito antes de ser recebido pelo laboratório.
    posPago:
        type: boolean
        description: Define se a amostra será paga após resultado ou antes.
    dataRecebimento:
        required: false
        type: string
        format: datetime
        description: Data na qual a amostra foi recebida pelo laboratório.
    dataPostagem:
        required: false
        type: string
        format: datetime
        description: Data na qual a amostra foi postada. Responsabilidade do cliente e/ou transportadora.
    dataDesegregacao:
        required: false
        type: string
        format: datetime
        description: Data na qual a amostra foi desegregada. Somente é preenchida se a amostra não poder ser processada no momento do recebimento.
    dataEntradaLaboratorio:
        required: false
        type: string
        format: datetime
        description: Data de entrada da amostra no laboratório.
    dataFinalizacao:
        required: false
        type: string
        format: datetime
        description: Data de finalização da amostra.
    coleta:
        type: object
        description: Dados da coleta registrada na amostra.
        required: false
        properties:
            tipoColeta:
                type: integer
                enum: [AVULSA, EQUIPAMENTO]
                required: true
            dadosColetaAvulsa:
                type: object
                required: false
                description: Dados da coleta para tipo AVULSA: é obrigatório, quando o tipo for avulso.
                properties:
                    nomeCompartimento:
                        type: string
                        required: true
                    tipoCompartimento:
                        type: object
                        required: true
                        properties:
                            id:
                                type: integer
                                required: true
                            nome:
                                type: string
                                required: true
                    obra:
                        type: object
                        required: false
                        properties:
                            id:
                                type: integer
                                description: Identificador único da obra/unidade no sistema.
                                required: true
                            nome:
                                type: string
                                description: Nome da obra e/ou unidade no sistema.
                                required: true
            dadosColetaEquipamento:
                type: object
                required: false
                description: Dados da coleta para tipo EQUIPAMENTO: é obrigatório, quando o tipo for equipamento.
                properties:
                    compartimento:
                        type: object
                        required: true
                        properties:
                            id:
                                type: integer
                                required: true
                            nome:
                                type: string
                                required: true
                            codigoExterno:
                                type: string
                                required: false
                            tipoCompartimento:
                                type: object
                                properties:
                                    id:
                                        type: integer
                                        required: true
                                    nome:
                                        type: string
                                        required: true
                    equipamento:
                        type: object
                        required: false
                        properties:
                            id:
                                type: integer
                                required: true
                            chassiSerie:
                                type: string
                                required: true
                            tagFrota:
                                type: integer
                                required: false
                            modelo:
                                type: string
                                required: true
                            codigoExterno:
                                type: integer
                                required: false
            dadosColetaGeral:
                description: Dados em comum aos dois tipos de coleta.
                type: object
                required: false
                properties:
                    dataColeta:
                        type: datetime
                        required: false
                        description: |
                            Data da coleta, informada pelo cliente no cartão/etiqueta ou no pré-registro da amostra no sistema. 
                            Formato é o ISO 8601 com time zone. Para maiores informações, veja https://en.wikipedia.org/wiki/ISO_8601
                    horasOleo:
                        type: integer
                        required: false
                        description: Quantidade de horas ou quilômetros ou periodos que o óleo da amostra possui.
                    oleoTrocado:
                        type: string
                        required: false
                        enum: ["NAO_INFORMADO", "SIM", "NAO"]
                        description: Informa se o óleo foi trocado após a coleta. Somente poderá ter dois valores. Caso o campo não seja informado, irá assumir 'Não informado'.
                    oleo:
                        description: Óleo ou fluido da amostra
                        type: object
                        required: false
                        properties:
                            fabricanteOleo:
                                type: object
                                required: false
                                description: Nome do fabricante do óleo.
                                properties:
                                    id:
                                        type: integer
                                    nome:
                                        type: string
                            viscosidade:
                                type: object
                                description: Viscosidade do óleo.
                                required: false
                                properties:
                                    id:
                                        type: integer
                                    nome:
                                        type: string
                            detalhesOleo:
                                type: string
                                required: false
                                description: Detalhes do óleo. Em geral, utilizado para informar o nome comercial do óleo, se é sintético, etc.
                            modelo:
                                type: object
                                description: Modelo do óleo.
                                required: false
                                properties:
                                    id:
                                        type: integer
                                    nome:
                                        type: string
                    volumeAdicionado:
                        type: string
                        required: false
                        description: Volume de óleo adicionado ao compartimento.
                    comentario:
                        type: string
                        required: false
                        description: Comentário do cliente na coleta da amostra.
    numeroCaixa:
        type: string
        required: false
        description: Número da caixa na qual o frasco foi despachado.
    notaFiscalFrasco: 
        type: string
        required: false
        description: Nota fiscal na qual o frasco foi emitido.
    camposExtras:
        type: array
        required: false
        description: Listagem dos resultados das análises feitas nesta amostra.
        items:
            type: CampoExtraAmostra
    mensagem:
        type: string
        required: true
        description: Mensagem do sistema.
    codigoErro: 
        type: integer
        required: true
        description: Código do erro ocorrido. O campo será 0 no caso de não ocorrerem erros no processamento da requisição.
